// The contents of this file are subject to the Mozilla Public License Version 1.1
// (the "License"); you may not use this file except in compliance with the License.
// You may obtain a copy of the License at <http://www.mozilla.org/MPL/>.
// 
// Software distributed under the License is distributed on an "AS IS" basis, WITHOUT
// WARRANTY OF ANY KIND, either express or implied. See the License for the specific
// language governing rights and limitations under the License.
// 
// The Original Code is the Venice Web Communities System.
// 
// The Initial Developer of the Original Code is Eric J. Bowersox <erbo@silcom.com>,
// for Silverwrist Design Studios.  Portions created by Eric J. Bowersox are
// Copyright (C) 2001 Eric J. Bowersox/Silverwrist Design Studios.  All Rights Reserved.
// 
// Contributor(s): 

importPackage(Packages.com.silverwrist.venice.core);
importPackage(Packages.com.silverwrist.venice.except);
importPackage(Packages.com.silverwrist.venice.ui);
importPackage(Packages.com.silverwrist.venice.ui.conf);
importPackage(Packages.com.silverwrist.venice.ui.helpers);
importPackage(Packages.com.silverwrist.venice.ui.view);

// get the request object and the community
rinput = bsf.lookupBean("request");
comm = rinput.getCommunity(true,"top.js.vs");

// get the current conference
currc = new CurrentConference(rinput);
conf = currc.getConference(true,"conf/conferences.js.vs?cc=" + comm.communityID);
on_error = "conf/manage_conf.js.vs?cc=" + comm.communityID + "&conf=" + conf.confID;

if (!(conf.canChangeConference()))
{ // you can't fiddle with this conference
  vlib.output(new ErrorBox("Access Error",
                           "You do not have permission to change this conference's customizations.",on_error));
  vlib.done();

} // end if

rc = null;
if ("GET"==rinput.verb)
{ // display the customization dialog
  try
  { // retrieve the existing customizations
    tmp = conf.getCustomBlock(ConferenceContext.CUST_BLOCK_TOP);
    if (tmp==null)
      tmp = "";
    rinput.setRequestAttribute("conference.custom.top",tmp);
    tmp = conf.getCustomBlock(ConferenceContext.CUST_BLOCK_BOTTOM);
    if (tmp==null)
      tmp = "";
    rinput.setRequestAttribute("conference.custom.bottom",tmp);

    // create the view
    rc = new JSPView("Customize Conference: " + conf.name,"conf/custom.jsp");
    rc.menuSelector = Content.MENU_SELECTOR_COMMUNITY;

  } // end try
  catch (e)
  { // error in getting custom blocks
    etype = vlib.exceptionType(e) + "";
    if (etype.match("DataException"))
      rc = new ErrorBox("Database Error","Database error getting customization blocks: " + e.message,on_error);
    else
      rc = e;

  } // end catch

  vlib.output(rc);
  vlib.done();

} // end if

if (rinput.isImageButtonClicked("cancel"))
{ // cancelled - bail out!
  vlib.output(new Redirect(on_error,LinkTypes.SERVLET));
  vlib.done();

} // end if

if (!(rinput.isImageButtonClicked("update")))
{ // what button got pressed?!?!?
  logger.error("no known button click on POST to conf/custom.js");
  vlib.output(new ErrorBox("Internal Error","Unknown command button pressed",on_error));
  vlib.done();

} // end if

try
{ // reset the custom blocks
  conf.setCustomBlock(ConferenceContext.CUST_BLOCK_TOP,rinput.getParameter("tx"));
  conf.setCustomBlock(ConferenceContext.CUST_BLOCK_BOTTOM,rinput.getParameter("bx"));

  // bounce back to the manage conference menu
  rc = new Redirect(on_error,LinkTypes.SERVLET);

} // end try
catch (e)
{ // error changing customizations
  etype = vlib.exceptionType(e) + "";
  if (etype.match("DataException"))
    rc = new ErrorBox("Database Error","Database error setting customizations: " + e.message,on_error);
  else if (etype.match("AccessError"))
    rc = new ErrorBox("Access Error",e.message,on_error);
  else
    rc = e;

} // end catch

vlib.output(rc);  // all done...
